{% extends 'base.html.twig' %}

{% block title %}Post index{% endblock %}

{% block body %}
    <div class="container-fluid">
        {{ include('post/new.html.twig') }}
   {% for post in posts %}
        <div class="card mx-auto" style="width: 50rem; margin-bottom: 10px">
            <div class="card-body">
                <h5 class="card-title">{{ post.title }}</h5>
                <p class="card-text">{{ post.content }}</p>
                {{ include('post/_comment_block.html.twig') }}
            </div>
        </div>
        {% else %}
            <div class="card mx-auto" style="width: 50rem;">
                <div class="card-body">
                    <p class="card-text">No Blog Found</p>
                </div>
            </div>
        {% endfor %}
    </div>
    
    {{ include('post/_edit_comment_modal.html.twig') }}
    {{ include('post/_delete_comment_modal.html.twig') }}
    
{% endblock %}
{% block javascripts %}
    
<!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://code.jquery.com/jquery-3.5.1.min.js" crossorigin="anonymous"></script>
    {# <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script> #}
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
    <script>
        $(function(){
            $('.add-comment').click(function(e) {
                
                e.preventDefault();
                var url = "{{ path('comment_new_ajax') }}";
                var $this = $(this).closest("form");//$(this);
                var formSerialize = $this.serialize();
                var current_comment_count_id = $this.parent().find(".comment_count").attr('id');
                var current_comment_count = parseInt($("#"+current_comment_count_id).text());
                var post_id = $this.parent().find(".comment_count").attr('id').replace('comment_count_','')

                $.post(url, formSerialize, function(response) {
                    //your callback here
                    var elem = $([
                            '<div class="be-comment"  id="comment-content-'+response.data.comment_id+'">',
                                '<div class="comment-content">',
                                        '<span class="comment-name">',
                                            '<a href="#">'+response.data.comment_author+'</a>',
                                            '</span>',
                                        '<span class="comment-time">',
                                            '<i class="fa fa-clock-o"></i>',
                                            response.data.comment_created_at.date,
                                        '</span>',
                                    '<p class="comment-text">',
                                        '<span>',
                                            '<label id="comment_content_text_'+response.data.comment_id+'">'+response.data.comment_content+'</label>',
                                        '</span>',
                                        '<span class="comment-time">',
                                            '<button type="button" class="btn btn-default btn-sm" onclick="editComment('+'&#39;'+response.data.comment_id+'&#39;'+','+'&#39;'+post_id+'&#39;'+')">',
                                                '<i class="fa fa-edit"></i>',
                                            '</button>',
                                            '<button type="button" class="btn btn-default btn-sm" onclick="deleteComment('+'&#39;'+response.data.comment_id+'&#39;'+','+'&#39;'+post_id+'&#39;'+')">',
                                                '<i class="fa fa-times"></i>',
                                            '</button>',
                                        '</span>',
                                    '</p>',
                                '</div>',
                            '</div>'
                        ].join("\n"));
                    if($this.parent().find($('.be-comment div')).length !== 0) {
                        $this.parent().find($('.be-comment div')).last().parent().after(elem);
                    } else {
                        $this.parent().find($('.comments-title')).after(elem);
                    }
                    
                    $("#"+current_comment_count_id).text(current_comment_count+1)
                }, 'JSON');
            });

            $('#edit-comment-form').submit(function(e) {

                e.preventDefault();
                var $this = $(this);
                var id = $this.find('#edit_comment_id').val()
                var url = "{{ path('comment_edit_ajax', { 'id' : 'id-param' }) }}";
                var url = url.replace("id-param", id);
                var formSerialize = $this.serialize();

                $.post(url, formSerialize, function(response) {
                    //your callback here
                    $("#comment_content_text_"+id).text(response.data.comment_content);
                    $('#editCommentModal').modal('toggle');
                }, 'JSON');
            });

            $('#delete-comment-form').submit(function(e) {
                e.preventDefault();
                var $this = $(this);
                var id = $this.find('#delete_comment_id').val()
                var url = "{{ path('comment_delete_ajax', { 'id' : 'id-param' }) }}";
                var url = url.replace("id-param", id);
                var formSerialize = $this.serialize();
                var current_comment_count_id = $this.parent().parent().parent().parent().find(".comment_count").attr('id');
                var current_comment_count = parseInt($("#"+current_comment_count_id).text());
                $.ajax({ url: url, method: 'DELETE', data: formSerialize})
                .then(function (response) {
                    $("#comment-content-"+id).remove();
                    $('#deleteCommentModal').modal('toggle');
                    $("#"+current_comment_count_id).text(current_comment_count-1)
                });
            });
        });

        function editComment(id, post_id) {
            $('#edit_comment_content').val($("#comment_content_text_"+id).text())
            $('#edit_comment_id').val(id)
            $('#edit_post_id').val(post_id)
            $('#editCommentModal').modal('show')
        }

        function deleteComment(id, post_id) {
            $('#delete_comment_content').val($("#comment_content_text_"+id).text())
            $('#delete_comment_id').val(id)
            $('#delete_post_id').val(post_id)
            $('#deleteCommentModal').modal('show')
        }
    </script>
{% endblock %}